; Copyright Formcroft Ltd 1997-1999
 .model small.486.code
 include always.inc; Assembler shorthands like 'Bptr' for 'byte ptr'.
 include declares.inc; Symbolic constants, macros, records, structures.
MyGroup GROUP _TEXT, BifSeg
BifSeg SEGMENT WORD PUBLIC 'CODE'
 dw BifFORM
 dw BifDATATYPE
 dw BifADDRESS
 dw BifARG
 dw BifCONDITION
 dw BifTRACE
 dw BifFUZZ
 dw BifDIGITS
 dw BifSOURCELINE
 dw BifXRANGE
 dw BifRANDOM
 dw BifREVERSE
 dw BifABS
 dw BifSIGN
 dw BifC2X
 dw BifB2X
 dw BifX2B
 dw BifX2C
 dw BifX2D
 dw BifC2D
 dw BifD2C
 dw BifD2X
 dw BifBITAND
 dw BifBITOR
 dw BifBITXOR
 dw BifVALUE
 dw BifCOPIES
 dw BifWORD
 dw BifWORDINDEX
 dw BifSUBWORD
 dw BifPOS
 dw BifLEFT
 dw BifSUBSTR
; Things which can't fail on argument type can be given simpler treatment.
;Some of these can use same Pcode point because number of args will distinquish.
; They need a bif number only so that messages can invert it to the name.
; Need specials high values. FORMAT with 5 args is special.
; Need these higher values than others.
 dw BifQUEUED
 dw BifSYMBOL
 dw BifCOUNTSTR
 dw BifCHANGESTR
 dw BifLENGTH
 dw BifMAX
 dw BifMIN
BifSeg ENDS

 PUBLIC BifNames; Used by messages to convert from bif number.
 PUBLIC Bifs; For lookup of spellings.
 PUBLIC BifGroup$$
 PUBLIC Bif$$
 PUBLIC Max$$
 PUBLIC Min$$
 PUBLIC Length$$
 PUBLIC Bifq$$
 PUBLIC Trace$$
 PUBLIC BifCHARIN, BifCHAROUT, BifSTREAM

 PUBLIC AfterCheck
 PUBLIC PcodeBif
 EXTERN B4VALUE1:near
 EXTERN B4VALUE2:near

 EXTERN Raise40p11:near
 EXTERN Raise40p32:near
 EXTERN Raise40p33:near
 EXTERN Raise40:near

 EXTERN BifCOUNTSTR:near
 EXTERN BifCHANGESTR:near
 EXTERN BifMAX:near
 EXTERN BifMIN:near
 EXTERN BifX2B:near; !! could be avoided.
 EXTERN BifD2X:near; !! could be avoided.
 EXTERN BifC2X:near; !! could be avoided.
 EXTERN BifB2X:near; !! could be avoided.
 EXTERN BifX2C:near; !! could be avoided.
 EXTERN BifX2D:near; !! could be avoided.
 EXTERN BifC2D:near; !! could be avoided.
 EXTERN BifD2C:near; !! could be avoided.
 EXTERN BifBITAND:near; !! could be avoided.
 EXTERN BifBITOR:near; !! could be avoided.
 EXTERN BifBITXOR:near; !! could be avoided.

 EXTERN UpperFirstAh:near
 EXTERN Bswitch:near
$BifSpecial equ $BifQUEUED
;------------------------------------------------------------------------------
; Make Pcode for a Bif.
;------------------------------------------------------------------------------
PcodeBif:; Here is Bif checking/generation.
; StackDx and StackDi come as the lo:hi bounds of parameters to be consumed.
; ParmsCl, Z.StackLo, Z.Stack are also set.
 mov StackDi,StackDx; StackDi to below leftmost arg.
; bx will address the checking data. $9.2.1
 mov Z.InsBif,bladd bx,bxmov SpecsBx,Wptr(Bswitch)[bx]
 mov Z.BifParmsHi,ParmsCl
; The byte before the label has the data we want.
BoundsDl is <dl>;
 dec SpecsBxmov BoundsDl,[SpecsBx]
; Isolate limits.
MinAh is <ah>;
MaxAl is <al>;
 mov MinAh,BoundsDlshr MinAh,ParmsMin
 mov MaxAl,BoundsDland MaxAl,mask ParmsXtrshr MaxAl,ParmsXtradd MaxAl,MinAh
; Usually the Pcode second byte will show BifNum and number of (optional) args.
; Special cases are MAX MIN & FORMAT
 cmp Z.InsBif,$BifFORMATjne @Fmov ax,MkMajMin(1,5)@@:
; 255 equals infinity because of $MaxParms
 cmp BoundsDl,(3 shl ParmsMin + 3 shl ParmsXtr)jb @Fmov ax,MkMajMin(1,255)@@:
 mov dh,ParmsClsub dh,MinAhshl dh,6add dh,Z.InsBifrol dh,1mov Z.BifByte,dh
ErrDl is <dl>;
 mov ErrDl,$n40p3; Possible error
 mov Z.Insert.ArgNum,MinAhcmp ParmsCl,MinAhjb DelayedRaise
 mov ErrDl,$n40p4mov Z.Insert.ArgNum,MaxAlcmp ParmsCl,MaxAlja DelayedRaise
; The ARG() count is good but that can include omitted arguments.
; x=arg(,'E') is not allowed.
 cmp Z.InsBif,$BifARGjne @Fcmp ParmsCl,2jne @Finc MinAh@@:
 mov ErrDl,$n40p5jmp TestOmitted
@@:inc chmov Z.Insert.ArgNum,ch
 Upcmp V.Dtype,$Omittedje DelayedRaise
TestOmitted:cmp ch,MinAhjne @B
; The presence/absence of arguments is OK, but they may not be the right types.
 mov StackDi,Z.StackLomov StackDx,Z.Stack; Hi end
; There are some special bifs for which type testing isn't relevant.
 mov al,Z.InsBif
; FORMAT with 5 parameters is special.
 cmp ParmsCl,5jne @Fcmp al,$BifFORMATje BifGroup@@:
 cmp al,$BifSpecialjb BifPlain
; LENGTH MAX MIN have their own Pcodes.
 sub al,$BifLENGTHjb BifGroupjz @F
; MAX & MIN need the (excess) parameter count.
 dec ParmsCladd al,al
@@:add al,$pLengthjmp PcodeOp

; QUEUE etc initially use the same runtime; number of parameters distinquishes.
BifGroup:OpRet $pBifGroup

; Put $pRaise and error code. Parsing will recover what more a message needs.
DelayedRaise:mov OpAppendCl,ErrDlOpRet $pRaise

comment~ Errors about number of arguments to a builtin have already been
tested.  BifTypes will check on the datatype of the arguments. This occurs
at both compile and run times. At compile time the intention is to put
any arguments that are constants into the best format for the job, eg the
letter "1" for a pad, the number 1 for a subscript position. If all relevant
arguments can be checked this way there is no need for a run time check.
Run time check has to be done in the order that the parameters appeared.
StackDi to StackDx are set for that order.

At run time we can raise error 40 as soon as a test fails. At compile time
it may "fail" because it is a variable and cannot be tested. In that case
we want to continue and check remaining arguments.
~

BifPlain:
; Bifs that can set the NotReady condition need a check at the end of the clause
; to see if it happened.  Set a flag now and compile a $pNop at end-of-clause.
 cmp al,$BifSTREAMja @FOn Z.Middles,EndClause@@:
; BifTypes expects StackDi,StackDx,SpecsBx. StackDi below 1st, StackDx at last.
 call BifTypes
; Here when BifTypes has been used at compile time.
; If all types were checked good, because they are consts, the faster form
; of Pcode can be used.
; Soft stack left with the parameters removed. Function action adds result.
 mov al,$pBifmov cl,Z.BifByte
; If any check failed, use $pBif which does tests at run time.
 btr Z.Program,BifCheckjc @Fmov al,$pBifq@@:
if ForBcode
 mov al,$pBifq; Rely on programmer when making Pcode to be translated to Bcode.
endif
 jmp PcodeOp

comment~ Originally this was coded so that DATATYPE had the option letter
converted to a compact numbering.  At assembler time this was done with
 Pos(<B>,<ABLMNSUWX>) sort of thing. Nowadays DATATYPE tests the uppercased
 letter instead of a number.
~

if Solid
WhichCheck:
; Minor msg number. Letter for DataType
; Difference of Whole and WholeNum is only in the conversion, not the test.
; The DATATYPE bif uses 'N' and 'W', which convert at current precision.
; CheckArgs needs a similar test, but with bif precision. Detect that
; as zero datatype.
; WholeGE needs to complain about wholeness in preference to about GE.
Assert $Whole     eq $-WhichCheckdb 12,' 'dw AnyRet
Assert $WholeGE   eq $-WhichCheckdb 12,' 'dw WholeGE$
Assert $WholeGT   eq $-WhichCheckdb 12,' 'dw WholeGT$
Assert $Num       eq $-WhichCheckdb 11,'N'dw AnyRet
Assert $M090      eq $-WhichCheckdb 17,'N'dw M090$
Assert $WholeNum  eq $-WhichCheckdb 12,'W'dw WholeNum$
; Pad is distinctive in not needing a DataType test. Internally nop.
Assert $Pad       eq $-WhichCheckdb 23,'$'dw Pad$
Assert $Hex       eq $-WhichCheckdb 25,'X'dw AnyRet
; The DATATYPE bif doesn't have Stream test. Internally we add one.
Assert $Stream    eq $-WhichCheckdb 27,'Z'dw AnyRet
Assert $Bin       eq $-WhichCheckdb 24,'B'dw AnyRet
Assert $Symbol    eq $-WhichCheckdb 26,'S'dw AnyRet
endif

; Pads have to be length one.
Pad$:call ToDsSiCxcmp cx,1jne Failed
AnyRet:ret

WholeGT$:; If we got this far it was a whole number. (Else was msg 40.12)
 mov al,14cmp V.Mantissa,ebpjne @Fjmp Failed

WholeGE$:mov al,13
@@:test V.Sign,1jnz Failedret

M090$:mov al,17
; If we tested here we would be able to put constants right a compile time,
; eg 41.10 => 41.1
; However, it seems easier to put the algorithm in Rexx.
; Fail on negative.
; Convert to string.
; Fail if 'E'
; Split at dot.
; Fail major > 90
; Kill trailing zeroes on minor
; Fail first digit of minor 9 unless only digit.
 ret

WholeNum$:
; What is this test ?? Only runtime use of ParmsHi?
 cmp Z.BifParmsHi,2jb @F
; !! what if too many digits for binary.
 test Bptr(V.Mantissa+3),80hjz @F
 mov al,13jmp Failed
@@:ret

; Maybe better code here if list of letters had been reversed but that would
; make producing <options> in a message harder.
; al holds negative of the length of the letter sequence.
; Trace is a special case - any number of leading question marks.
LetterList:cbwdec SpecsBx
 cmp Bptr[SpecsBx],'?'jne PostTrace

; What to do with '?' of the subject !!
 inc axdec SpecsBx
; Make it a runtime problem.
 cmp V.Dtype,$Variableje Failed
 cmp V.Dtype,$Constantje Failed
; Throw them away for now.         NYI
Qdrop:call ToDsSiCxJcxzQ PostTrace
 cmp Bptr[si],'?'jne PostTrace
; take SUBSTR(it,2)
 Upmov V.ExpAnd,ebpmov V.Mantissa,ebpmov Bptr(V.Mantissa),2
 mov al,0push SpecsBxpush PostSubstrpush sijmp BifSUBSTR
PostSubstr:pop SpecsBxjmp Qdrop

PostTrace:
; About to check an options letter against the list.
; We may need the list for a syntax msg.
 mv ds,cs
 inc ax
 mov Z.Insert.OptsHi,SpecsBxadd SpecsBx,axmov Z.Insert.Options,SpecsBx
 mov cl,V.Dtype
; Parameter == '' is SYNTAX 40.21
 mov al,21cmp cl,$NullStringje Failed
 cmp cl,$Constantjne @F
 mov si,V.WhichConmov ds,Z.ProgScopecmp Vsid.Dtype,$NullStringje Failed
@@:
; Special case for STREAM bif, but I'll do that in the STREAM routine.
; (If the second argument isn't 'C' then a third is wrong.)
; Parameter omitted will be defaulted.
 cmp cl,$Omittedje NoLetter
; Uppercase the parameter, and shorten to one char.
; At compile time we may alter the constant.
 mov ah,'O'cmp cl,$Constantjne @Fcall ConstValueX@@:
 mov al,28
; More by luck than good coding this doesn't change $Variable things to letters.
 call UpperFirstAh
 mv ds,cs
; See if match in string.
 dec SpecsBx
@@:inc SpecsBxcmp SpecsBx,Z.Insert.OptsHija Failedcmp ah,Bptr[SpecsBx]jne @B
NoLetter:
 mov SpecsBx,Z.Insert.Optionsjmp AfterCheck

; Here is a set of ways of raising SYNTAX, jumped to from the bif testing.
; The numeric tests can fail with "Exponent out of range."
; Change 40.11 to 40.9 if exponent too big.
;MASM........................
Failed:
 btr Z.Cancel,ExpRangejnc @Fmov al,9@@:
; Z.Insert.Value will be good for Value insert. (Raise will set it from StackDi)
; Z.Insert.Options is good if relevant.
; Z.Insert.ArgNum has been maintained.
; Z.InsBif has not been set, the rescan will do that.
; al has been set to minor code.
; CursorSi was pushed early on for line number.
; When Bif parameters are checked at compile time a failure will come here.
; Instead of following through we need to continue checking, with a flag
; to ensure we eventually make code to check again at run time.
 cmp Z.Scanp,ZeroBpjz Raise40
; Assert SpecsBx, StackDi, StackDx in play.
 mov sp,Z.StashOn Z.Program,BifCheckjmp AfterCheck

; These bifs have a fixed number of arguments so we can economize on codes by
; distinguishing them here. Only FORMAT requires argument checking.
BifGroup$$:
 mov bl,Bptr gs:[CursorSi]
 inc CursorSipush CursorSi
 cmp bl,5jne @F
 mov bl,2*$BifFORMATmov al,4On Z.Cancel,Format5jmp FromFORMAT5
@@:add bl,$BifQUEUEDadd bx,bxz al
 jmp FromBifGroup

; Bif, and Bifq both invoke a builtin function.
; Bif$$ does full checking.
Bif$$:push CursorSi
comment~ The parameters are checked before calling the Bif, against data which
is held adjacent to the machine code peculiar to that Bif.  This has to be done
in the order that they appeared.

~
 mov al,gs:[CursorSi]mov bl,aland bl,7Eh
; InsBif isn't needed for potential error message because parser will be
; reused to synch the message and that sets InsBif.
SpecsBx is <bx>; SpecsBx will address the checking data. $9.2.1
 ror al,7and al,3
FromFORMAT5:
 mv ds,csmov bx,(Bswitch)[bx]
; Combine the count of optional parameters now in al with count of mandatory.
 dec SpecsBxmov cl,Bptr[SpecsBx]shr cl,ParmsMinadd al,clmov Z.BifParmsHi,al
; Set StackDi to address any parameters from below the leftmost.
 mov StackDx,StackDimov ah,$StrideVmul ahsub StackDi,ax
BifTypes:; Note this routine is used both at compile and run times.
; Hence care with segment register non-use or reload.
; Either way label Raise handles things that don't pass the testing.
; The number of parameters has already been checked, because that is always a
; compile time job.
; At this point, it is SpecsBx, StackDi and StackDx that define to-be-done.
 mov Z.Insert.ArgNum,0push StackDx
; First byte says which parameters need checking.
 mov al,Bptr[SpecsBx]shl al,8-width NonCheck
 mov Z.Stash,sp; To tidy up in Failed.
 mov Z.Flags,aljmp AfterCheck
ParmLoop:inc Z.Insert.ArgNumshl Z.Flags,1jc AfterCheck

comment~ A parameter omitted is bound to be OK since if it was a mandatory
position some $pRaise Pcode would already have been substituted.  But we can't
just skip those yet because of need to default.  Subsequent bytes are either a
list of letters for checking an option, or some value denoting another test.
All the CheckArgs tests are here, plus some others.

~
 dec SpecsBxmov al,Bptr[SpecsBx]cmp al,-@SizeStr(<ACEFILNOR?>)jae LetterList
 cmp V.Dtype,$Omittedje AfterCheck
; StackDi is for the current argument, StackDx yields how many there were.
; The table at WhichCheck gives input to a datatype test plus actual address
; of a relevant particular test.
 movzx si,aladd si,WhichChecklodsw
; Make a version of a constant argument that is of suitable type, if possible.
; ah is type letter.
 cmp V.Dtype,$Constantjne @F
; Only happens at compile time.
 call ConstValueX
@@:
; The test of $Variable is only relevant at compile time and wouldn't be
; needed if I made sure conversions always failed for that type.
 cmp V.Dtype,$Variableje Failed
; al now will be minor message number. ah will be letter option for datatype.
; Carry will be set on by DataType if the type test fails.
; Otherwise DataType will convert the argument, according to ah.
; DataType doesn't do its own saving; sometimes called with nothing to save.
 push SpecsBxpush StackDxpush sipush axmov al,ahcall DataTypepop ax
 pop sipop StackDxpop SpecsBx
 mv ds,cs
 jc Failed
; Symbol is only checked as the first parameter of VALUE, and can't be wrong
; then if there is a third parameter.
; I have decided to test this only in the BifVALUE code.
 call Wptr[si]; For specialized tests on the argument.
 mv ds,cs
AfterCheck:Upcmp StackDi,StackDxjna ParmLoop
; Reached here if no check failed.
 pop StackDiz bh
; If BifTypes was used from compile time it returns from here.
 cmp Z.Scanp,ZeroBpje @Fret@@:
 Qry Z.Cancel,Format5jz @F
; Typical Format awkwardness.
 mov al,4mov bl,2*$BifFORMATjmp FromBifGroup
@@:
 pop CursorSi
; End of Bif$$ pre-checking of arguments. Now is like Bifq$$.
;------------------------------------------------------------------------------
; The XCycle fans to Add$$, Iterate$$ etc.  Bifq$$ is another fan-out.
;  (Bif$$ does parameter checking on the way to Bifq$$ when necessary.)
;------------------------------------------------------------------------------
Bifq$$:lodsb gs:[CursorSi]push CursorSi; Many Bifs need to use this.
comment~ Design note - the "bif byte" has the middle six bits determining the
bif and the sign+oddness bits saying how many parameters beyond the minimum
required for that bif.  Using two bytes would avoid some complexity, trade a
little Pcode size for a little speed.  Note, however, that use of sign+oddess
means the count can be put in the hardware flags with one test instruction.

~
; Pick up address of BifABBREV or whatever it is.
 mov bl,aland bl,7Eh
FromBifGroup:
 mov si,cs:(Bswitch)[bx]
; Some are hard codes, some use Bcodes.
; BEWARE - this test depends on the order in which object modules are linked.
 cmp si,offset BifBoundjb BifBcoded
; Adjust the optional extra parameters out of the StackDi position.
 mov bl,aland bl,81hrol bl,$ShiftV+1sub StackDi,bx
; The bif routines are entered with:
;AH free, AL showing what optional parameters were present. (need not preserve)
;BH zero, BX free
;CH free, CL showing options letter as number, where relevant. (need not pre..)
;DX free
;SI free Must be restored on return, by pop.
;DI addressing the last mandatory argument. On return must address result.
;DS free
;ES free
;FS not free
;GS not free
;Extended parts of registers can be changed.
 jmp si; Will return to XCycle

; When we come from setting up a builtin AL describes the builtin and number
; of actual arguments. SI addresses the implementing Bcode and the byte
; before that gives the maximum possible number of optional arguments.
; (Exception - MAX and MIN)
; The stack about to be padded with $Omitted arguments so that the implementing
; code always sees the same amount of stack for arguments.
; (Z.ArgsB0 and Z.ArgsB also say where args are; this needed for MAX/MIN)
; CursorSi is now the cursor on Bcode.
; The CursorSi position has been pushed. (That is Pcode position if top level.)
; Set ah to allowed extras, al to extras on this invocation.
comment~ The test that brings us here distinguishes Bcode/machinecode. That
doesn't allow for a bit of machine code as a preamble for a particular bif,
followed by Bcode for that bif.  So if we want to do something like that, it
will havee to be tested here. (Change to a more efficient way one day)
~
BifBcoded:
 cmp bl,2*$BifBITANDjne @F
 mov Dptr(Ve.String[$?BIF]),StringOrder('B','I','T','A')
 mov Dptr(Ve.String[$?BIF+4]),StringOrder('N','D',0,($NullString+6))
 jmp BifUsual
@@:cmp bl,2*$BifBITORjne @F
 mov Dptr(Ve.String[$?BIF]),StringOrder('B','I','T','O')
 mov Dptr(Ve.String[$?BIF+4]),StringOrder('R',0,0,($NullString+5))
 jmp BifUsual
@@:cmp bl,2*$BifBITXORjne @F
 mov Dptr(Ve.String[$?BIF]),StringOrder('B','I','T','X')
 mov Dptr(Ve.String[$?BIF+4]),StringOrder('O','R',0,($NullString+6))
 jmp BifUsual
@@:cmp bl,2*$BifFORMATjne BifUsual
 mov ah,4; Max extras.btr Z.Cancel,Format5jc Format5njmp Formatn
BifUsual:mov ah,cs:[CursorSi-1]and ah,mask ParmsXtrshr ah,ParmsXtr
Formatn:rol al,1and al,3
Format5n:mov Z.ArgsB,al; Actual extras.jmp BifArgPad
@@:Upmov V.Dtype,$Omittedinc ax
BifArgPad:cmp al,ahjne @Bjmp LinkBcodeX

; Bifs implemented. Data for checking parameters ahead of the machine code.

if Solid
;$9.3.6
 db $WholeGEParmsRec <2,0,1011b>
BifCOPIES:
endif
 mov bx,V.MantLowDown
; Zero copies returns null string.
 TestReg bxjnz @Fmov V.Dtype,$NullStringRetSi@@:
 call ToDsSiCxJcxzQ @3p6ret
 Move V2,V,edx
; Setup for result loses first argument.
 xax cxmul bxjc Raise5p1dxax cxcall ResultSpace
; In case compaction.
 Upcall ToDsSiCxDown
 push StackDimov di,ax
@@:push cxpush sirep movsbpop sipop cxdec bxjnz @B
 pop StackDi
@3p6ret:jmp BackEsSi

if Solid
;$9.3.8
 db "ABLMNSUWX"db -@SizeStr(<ABLMNSUWX>)ParmsRec <1,1,1011b>
BifDATATYPE:
endif
 test al,81hjnz @F
 inc bhmov al,'N'jmp WithLetter
@@:Upcall UpperFirstAhmov al,ahDown
WithLetter:call DataType
; Carry is set if *not* this type.
 mov eax,ebpjc @Finc ax@@:
 mov V.Mantissa,eaxmov V.ExpAnd,ebp
 test bh,bhje BifDret
 mov V.Dtype,$NullString+3
 mov Dptr(V.String),StringOrder('N','U','M',' ')
 dec axjz BifDret
 mov V.Dtype,$NullString+4
 mov Dptr(V.String),StringOrder('C','H','A','R')
BifDret:pop CursorSiBackRet

DataType:
; DataType determines whether the data type of the value on the stack is
; as expected, and does some conversion.
; On entry StackDi gives the subject.
; On entry al is the option letter.
; On exit carry is Boolean for "not as expected"
; A side-effect of some types is to "normalise" the subject.

; al blank on entry means that this is one of the tests for whole numbers
; with bifs. The test for number syntax is the same as with 'N' but the
; integerness test may be different because always at precision 9.
; ToWholeEbx also used for FOR argument etc.
 cmp al,' 'je ToWholeEbx

; Get the null string cases out of the way
 cmp V.Dtype,$NullStringjne TqNonNull
 cmp al,'B'je @Fcmp al,'X'je @Fcmp al,'Z'je @Fstc@@:ret

TqNonNull:pusha
; The three major representations are number, short string, and long string.
; A particular Rexx value can be held in different representations.
 mov bx,Attributes; For potential XLAT

 cmp al,'N'jne DNotN
; !! Is current digits, not 9.  Carry from NumDxBx is bad syntax.  jnz for bin.
 call NumDxBxjc TqFailjmp TqOK
DNotN:
 cmp al,'W'jne DNotW
; WholeNum. DATATYPE uses the current digits.
 call ToWholeEbxjc TqFailjmp TqOK

DNotW:
 call ToDsSiCx
 mov bx,Attributes
 cmp al,'A'jne DNotA
; Letters and digits OK. Not including '_' etc which our table has as letters.
; Not including '.' which our table has as a letter.
; Sadly. '@' is mixed in with the uppercase letters in ASCII sequence.
@@:lodsbcmp al,'0'jb TqFailcmp al,'@'je TqFail
 cmp al,'.'je TqFailXlatBDLSjpe TqFailloop @Bjmp TqOK
DNotA:

 cmp al,'B'jne DNotBmov dx,MkMajMin(3,$OKb)jmp FromB
DNotB:

 cmp al,'L'jne DNotL
; Lower case OK, same as uppercaseable letter/digit
@@:lodsbXlatBDLSjpe TqFail
 test al,$Lowercasejnz TqFailloop @Bjmp TqOK
DNotL:

 cmp al,'M'jne DNotM
; Mixed, same as 'A' except excludes digits.
@@:lodsbcmp al,'A'jb TqFailXlatBDLSjpe TqFailloop @Bjmp TqOK
DNotM:

 cmp al,'S'jne DNotS
; Not easy to share Symbol test with compile time.
 cmp cx,$Limit_Nameja TqFail
; Dot as letter.
; What about reserveds in SYMBOL()?
@@:lodsbXlatBDLSjpe TqFailloop @Bjmp TqOK
DNotS:

 cmp al,'U'jne DNotU
; Upper
@@:lodsbcmp al,'A'jb TqFailcmp al,'Z'ja TqFailloop @Bjmp TqOK
DNotU:

 cmp al,'X'jne DNotX
; The same loop is used for hex and binary, with parameters.
; To test for valid chars, RadixTypeDl.
; To test for blanks badly placed dh, 1 for Hex, 3 for Bin.
 mov dx,MkMajMin(1,$OKx)
FromB:
; Check first and last of content for blanks.
 mov al,[si]XlatBDLSjz TqFail
 add si,cxdec simov al,[si]XlatBDLSjz TqFail
; Check the string content which goes down from si for cx.
; Whitespace is allowed for formatting.
; But not at ends or in middle of nibbles.
 z Z.DigitCount
 std
RadiLoop:lodsb [si]XlatBDLSjnz NonWhi
 test Bptr Z.DigitCount,dhjnz TqFail
 jmp @F
NonWhi:jpe TqFail; Not a letter or digit
 test AttribAl,RadixTypeDljz TqFail; Not good for this radix
 inc Z.DigitCount
@@:LoopQ RadiLoop
 jmp TqOK
DNotX:

; Here would be test for allowable characters in a stream name.
; cmp al,'Z'    NYI
 jne DNotZ

TqFail:popacldstcret

DNotZ:; Pad type always succeeding.
TqOK:popacldclcret

Max$$:inc bh
Min$$:lodsb gs:[CursorSi]mov Z.ArgsB,alinc ax; Actual args.
; Check Numberness in the original order.
 mov ah,-$StrideVimul ah
 mov cx,StackDiadd StackDi,axmov Z.ArgsB0,StackDimov Z.Insert.ArgNum,0
 push bx
@@:inc Z.Insert.ArgNumUpcall NumDxBxjc Raise40p11cmp StackDi,cxjne @B
 pop bx
; Actual function is Bcoded.
 mov dx,BifMAXtest bh,bhjne @Fmov dx,BifMIN@@:jmp LinkBcode

if Solid
;$9.3.13
 db $Paddb $WholeGEParmsRec <2,1,1001b>
BifLEFT:
endif
 test al,81hjz @3p13Two
 add Z.Stack,$StrideV
; LEFT(a,b,c) ==> SUBSTR(a,1,b,c)
; SUBSTR with four args, two mandatory.
 add al,1
; Move pad field one further up, after ensuring it is char.
; Avoid check if Bcode didn't use Bifq$$ all the time.(Best avoided compiletime)
 Upcall ToDsSiCxDown
 mov cl,V2.Stringmov V3.String,cl
 mov V3.Dtype,$NullString+1
@3p13Two:
; LEFT(a,b) ==> SUBSTR(a,1,b)
; SUBSTR with three args, two mandatory.
 add al,80h
; Move length field one further up.
 mov ecx,V.Mantissamov V2.Mantissa,ecx
 mov ecx,V.ExpAndmov V2.ExpAnd,ecx
; Set what was length field to 1.
 mov V.Mantissa,ebpmov V.ExpAnd,ebpinc Bptr V.Mantissa
 jmp BifSUBSTR

if Solid
;$9.3.16
 db $WholeGTParmsRec <2,1,1101b>
BifPOS:
endif
; Start above Haystack above Needle.
 call ToDsSiCxDown
 test al,81hz axjcxz @3p16Donejns @3p16Two
; Adjust when start position given.
 mov dx,V3.MantLow
 cmp dx,cxja @3p16Donemov ax,dx
 dec axadd si,axsub cx,ax
; ax is contribution to result.
@3p16Two:
; NYI push ds unsound?
 push dipush dspush sipush cxcall ToDsSiCx; For Needle
; bx = Hay length. di=Hay pos.  es=Hay seg.
 pop bxpop dipop esJcxzQ @3p16Nonesub bx,cxjb @3p16None
; ax to be result. Usual registers for repe cmpsb. bx detects end of Haystack.
@3p16loop:inc axpush sipush dipush cxrepe cmpsbpop cxpop dipop si
 je @3p16xinc didec bxjns @3p16loop
@3p16None:z ax
@3p16x:pop di
@3p16Done:mov V.ExpAnd,ebpmov V.Mantissa,ebpmov V.MantLow,ax
 jmp BackEsSi

if Solid
;$9.3.17
 ParmsRec <1,0,1111b>
BifREVERSE:
endif
; Setup for result loses first argument.
 Move V2,V,edx
 call ToDsSiCxJcxzQ @9p3p17
 call ResultSpace
 xax bxadd bx,cx
 Upcall ToDsSiCxDown;
@@:lodsbdec bxmov es:[bx],alloop @B
@9p3p17:jmp BackEsSi

if Solid
;$9.3.21
 db $Paddb $WholeGEdb $WholeGTParmsRec <2,2,1000b>
BifSUBSTR:
endif
; Setup to be  V2 (bx+1) is position, V3 (dx) is length, V4 is pad char, pad
; length ax.
if 1
; NYI Bcode to explicitly make number where required?
 test V.Dtype,$Testjz @Fcall NumDxBx@@:
endif
 mov bx,V.MantLow
 Downcall ToDsSiCxdec bx
; Lower position offset, bx, to within string or at end.
 cmp bx,cxjna @Fmov bx,cx@@:
 test al,81hjs @3p21Threejpo @3p21Four
; Two arguments. Default length is the rest.
 mov dx,cxsub dx,bx
; When there is no padding there will be no need for allocate and move.
@3p21NoPad:cmp dx,7jna @F
 add V.Pt,bxmov V.Len,dxpop CursorSiBackRet
@@:add si,bxmov ecx,Dptr[si]mov ebx,Dptr[si+4]
 mov Dptr(V.String),ecxmov Dptr(V.String+4),ebx
 add dl,$NullStringmov V.Dtype,dl
BackEsSi:
 mov ProgEs,Z.ProgScope
 pop CursorSi
 BackRet

@3p21Alloc:;cx pad length, dx total length, ds:si source.
xchg cx,dxcall AllocateCx_EsAxxchg dx,cxjnc @3p21Move
; Compaction will have invalidated ds:si
 push cxcall ToDsSiCxpop cxjmp @3p21Move

; Default pad is ' '
@3p21Three:mov Bptr(V4.String),' '
@3p21Four:
; Arg 3 is known to be binary since if the types were checked at runtime it
; would have been converted then and if the types passed check at compile
; time the constant would be stored as binary.
; (For Bcode there is risk but hopefully they are coded to cope.)
 mov dx,V3.MantLow
; Data move is necessary only if there is padding. Change cx to amount of pad.
 mov ax,bxadd ax,dxsub ax,cxjna @3p21NoPadmov cx,ax
; New space not necessary for short results.
 cmp dx,7ja @3p21Allocmv es,dsmov ax,si; es:ax is target.
@3p21Move:push axsub dx,cxxchg cx,dx; cx chars from original, dx chars of pad
; Copy it. Direction of move is OK when source is short.
 push StackDiadd si,bxmov bl,V4.Stringmov di,axRepmovsb
 mov al,blmov cx,dxrep stosbpop StackDi
 mov ax,V3.MantLowcmp ax,7ja @3p21Long
 add al,$NullStringmov V.Dtype,alPopJunk si
 jmp RetEsSi

@3p21Long:mov V.Len,axmov V.Sg,espop V.Pt
 call Away
 jmp RetEsSi

if Solid
;$9.3.22db $WholeGEdb $WholeGTParmsRec <2,1,1001b>
BifSUBWORD:
endif
 Downmov V4.Dtype,al;Just a place to save it.
; V3 is optional, number of words.
 test al,81hjz @Fdec V3.MantLowjs @3p22Null@@:
; Address string, move si to first wanted word.
 call ToDsSiCxcall WordIndex
 JcxzQ @3p22Null
 dec simov dx,si
; Omitted third parameter means all residual string except trailing blanks.
 test V4.Dtype,81hjz @3p22Clip
; Move on past word that was found.
@@:lodsbXlatBDLSjz @FLoopQ @Bjmp @3p22Done
; Third parameter is count of words. (Already decremented)
@@:dec simov ax,V3.MantLowTestReg axjz @3p22Donemov V2.MantLow,ax
; Move on to beginning of the last word.
 call WordIndexJcxzQ @3p22ClipXdec cx
; Move on past that word.
@@:lodsbXlatBDLSjz @FLoopQ @Binc si@@:dec si
; Wanted is from dx up to si.
@3p22Done:mov cx,simov si,dxsub cx,si
 cmp cx,7ja @3p22Long
 mov edx,Dptr[si]mov ebx,Dptr[si+4]
 mov Dptr(V.String),edxmov Dptr(V.String+4),ebx
 add cl,$NullStringmov V.Dtype,clpop CursorSiBackRet
; If it is long now it must have been a long source.
@3p22Long:mov V.Pt,simov V.Len,cxpop CursorSiBackRet
@3p22Null:mov V.Dtype,$NullStringpop CursorSiBackRet

@3p22ClipX:; Recovery end position.call ToDsSiCx
@3p22Clip:; Scan back from far endadd si,cx
@@:mov al,Bptr[si-1]XlatBDLSjnz @3p22Donedec sijmp @B

if Solid
;$9.3.25db $WholeGTParmsRec <2,0,1011b>
BifWORD:; Set what will be third arg of subword.
endif
 mov V2.Mantissa,ebpmov Bptr V2.Mantissa,1
 mov al,80h; Tell SUBWORD of extra parameter.
 jmp BifSUBWORD

if Solid
;$9.3.26db $WholeGTParmsRec <2,0,1011b>
BifWORDINDEX:; Share subroutine with SUBWORD.
endif
 Downcall ToDsSiCx; Address the string.
 mov dx,sicall WordIndexsub si,dxmov V.MantLow,si
 mov V.ExpAnd,ebpz V.MantHighpop CursorSiBackRet

WordIndex:; Used on Ds:Si:Cx. If not found si not changed (and cx=0), else
; si one beyond found character (and cx one more than matching si).
; Requires V2.Mantissa as first word count, which is zeroed.
; ax is altered, bx set to the table.
 push siJcxzQ @3p26Zero
 mov bx,Attributes; Prepare to test AllBlanks.
; Move SI on to nonblank.
 inc si
@3p26LoopX:dec si
@3p26Loop:lodsbXlatBDLSjnz @FLoopQ @3p26Loopjmp @3p26Zero
; Is this the wanted word?
@@:dec V2.Mantissajz @3p26
 dec si; Simplest
; Move SI on to blank and cycle.
@@:lodsbXlatBDLSjz @3p26LoopXLoopQ @B
@3p26Zero:pop CursorSiBackRet
@3p26:pop axret

if Solid
;$9.3.30
 db $Paddb $PadParmsRec <0,2,0011b>
BifXRANGE:; cl for 'around to', dl for 'first value'.
endif
 z dxmov cx,0FFhtest al,81hjz @3p30mov cl,V2.Stringjs @3p30
; Two extras present.
 mov dl,V2.String
 mov cl,V3.String
@3p30:sub cl,dlinc cx
 Up
 call ResultSpace
 JcxzQ @3p30ret
 push StackDi
 mov di,axmov al,dl
@@:stosbinc alloop @B
 pop StackDi
@3p30ret:
 jmp RetEsSi

if Solid
;$9.4.1
 db $NumParmsRec <1,0,0111b>
BifABS:
endif
 call NumDxBx; !! not required when we change constants.
; Longs in bifs !!
 and V.Sign,0FEhpop CursorSiBackRet

if Solid
;$9.4.5
 db $NumParmsRec <1,0,0111b>
BifSIGN:
endif
 call NumDxBx
 mov ecx,ebptest V.Sign,1jz @Finc cxmov V.ExpAnd,ecxjmp @4p5@@:
 mov V.ExpAnd,ebpcmp V.Mantissa,ebpjz @4p5inc cx
@4p5:mov V.Mantissa,ecx
 pop CursorSiBackRet

if Solid
;$9.5.1
 db "EINO"db -@SizeStr(<EINO>)ParmsRec <0,1,0111b>
BifADDRESS:; More to come
endif
 call HeritageDi
; L.Active.EnvNumber identifies the address. Jan 00 not decided on where
; actual name is.
 pop StackDi
; Return "DOS" for now.
 Up
 mov ecx,Y.DOS
 mov Dptr(V.String),ecx
 mov Bptr(V.Dtype),$NullString+3
 pop CursorSiBackRet

if Solid
;$9.5.2
 db "ENO"db -@SizeStr(<ENO>)db $WholeGTParmsRec <0,2,0011b>
BifARG:
endif
; Moot point whether we should have put both ends of arglist in the
; Level block.  (Loses when BifARG not used.)
; Si to be result, most cases.
 Upcmp Z.ResumeP,ZeroBpje @5p2Pcode
; Crude for BCycle bifs.  Only MAX MIN FORMAT use arg() internally.
 movzx si,Z.ArgsBinc sitest al,81hjz @5p2None
; Numeric arg index to bx
 call NumDxBxmov cx,Z.ArgsB0jmp @5p2One

@5p2Pcode:mov si,Z.Levelmov cx,Lsi.Arg0sub si,$StrideL
 sub si,cxshr si,$ShiftV; arg()test al,81hjz @5p2None
; Numeric arg index to bx
 call NumDxBxtest al,81hjs @5p2One
; There is an option.
 Upcall UpperFirstAh; to ahDown
; arg(9999) will be non-existant
 cmp bx,siz sija @5p2Omitted
 shl bx,$ShiftVadd bx,cx
 cmp Vbxs.Dtype,$Omittedje @Finc si@@:
@5p2Omitted:cmp ah,'O'jne @5p2None
 xor si,1
@5p2None:; Use si as the result.
 mov V.ExpAnd,ebpmovzx esi,simov V.Mantissa,esi
@5p2Ret:pop CursorSiBackRet
@5p2One:cmp bx,simov V.Dtype,$NullStringja @5p2Ret
 shl bx,$ShiftVadd bx,cx
 Move V,Vbxs,edx
 jmp @5p2Ret

if Solid
;$9.5.3
 db "CDEIS"db -@SizeStr(<CDEIS>)ParmsRec <0,1,0111b>
BifCONDITION:
endif
 Up; Arg, will be result.
 test al,81hjz @5p3I; Default is 'I'
 call UpperFirstAh
 cmp ah,'D'jne @F
 call HeritageDimov LevelSi,LevelDipop StackDi
 Move V,Lsi.ConditionDescription
 RetSi
@5p3I:
@@:Error49Bp

if Solid
;$9.5.4
 ParmsRec <0,0,1111b>
BifDIGITS:
endif
 mov cx,Z.Digits
@5p4Like:Upz V.MantHighmov V.MantLow,cxmov V.ExpAnd,ebp
 pop CursorSiBackRet
if Solid
;$9.5.6
 ParmsRec <0,0,1111b>
BifFORM:
endif
 call HeritageDimov al,L.Formpop StackDiUp
 mov bx,$?Scmp al,'S'je @Fadd bx,$?E-$?S@@:
 Move V,Vbxe
 pop CursorSiBackRet

if Solid
;$9.5.7
 ParmsRec <0,0,1111b>
BifFUZZ:
endif
 mov cx,Z.Fuzzjmp @5p4Like

if Solid
;$9.5.8
 db $WholeGTParmsRec <0,1,0111b>
BifSOURCELINE:
endif
 lds bx,Z.SysFilemov ecx,F.Lines
 test al,81hjnz @5p8One
; No args - return line count of file.
 call Zero$$mov V.Mantissa,edx
 RetSi
@5p8One:; Check against current source file line count.
 Upcall ToWholeEbxcmp ebx,ecxmov al,34ja Raise40
 Error49Bp; NYI

if Solid
;$9.5.9
TraceVerb$:
  db "ACEFILNOR?"db -@SizeStr(<ACEFILNOR?>)ParmsRec <0,1,0111b>
BifTRACE:
endif
; 2011 There is no mandatory argument to TRACE. So the general bif
; mechanism will have set StackDi to reflect no argument and set
; Al to the Pcode byte value, which contains count of the optionals.
; Collect any parameter, setup LevelDi, and note previous trace setting.
 z sitest al,81hjz @FUpcall ToDsSiCxDown@@:
 call HeritageDimov dx,L.TraceWord
; If there was a parameter, alter trace setting to reflect it.
 TestReg sijz @5p9Showmov al,'N'JcxzQ @5p9Null
@@:lodsbcmp al,'?'jne @Fbtc L.TraceWord,InteractiveLoopQ @Bjmp @5p9Show
@@:cmp al,'a'jb @Fcmp al,'z'ja @Fand al,0DFh@@:cmp al,'O'jne @F
@5p9Null:Off L.TraceWord,Interactive@@:mov L.TraceLetter,al
@5p9Show:; Letter or Questionmark letter.
; 2011 Up whether optional or not, to place for result.
; pop StackDiTestReg sijnz @FUp@@:
 pop StackDiUp
 mov al,$NullString+1Qry dh,Interactivejz @Finc axmov dh,dlmov dl,'?'@@:
 mov Wptr(V.String),dxmov V.Dtype,alRetSi

Trace$:call ToDsSiCxcall HeritageDimov al,'N'JcxzQ InterOff
@@:lodsbcmp al,'?'jne @Fbtc L.TraceWord,InteractiveLoopQ @Bjmp TraceRet
@@:cmp al,'a'jb @Fcmp al,'z'ja @Fand al,0DFh@@:
; Test match in string.
 mv ds,csmov SpecsBx,TraceVerb$mov cx,@SizeStr(<ACEFILNOR>)
@@:cmp al,Bptr[SpecsBx]je TraceOKinc SpecsBxloop @B
 pop StackDimov V.String,almov ax,MkMajMin(24,1)
 mov V.Dtype,$NullString+1jmp Raise
TraceOK:cmp al,'O'jne @F
InterOff:Off L.TraceWord,Interactive
@@:mov L.TraceLetter,al
TraceRet:pop StackDiDownpop CursorSijmp DualSwitch

; TRACE verb.
Trace$$:push CursorSi
; Omitted parameter was supplied at compile time.
 call NumDxBxjc Trace$
 call ToWholeEbxmov ax,MkMajMin(26,7)jc Raise
; Z.InhibitTrace Z.InhibitPauses NYI
 pop CursorSi
 jmp DualSwitch

if Solid
;$9.7.1
 db $WholeGEdb $WholeGTdb $StreamParmsRec <0,3,0001b>
BifCHARIN:
endif
 Error49Bp

if Solid
;$9.7.2
 db $WholeGTdb $StreamParmsRec <0,3,0101b>
BifCHAROUT:
endif
 Error49Bp

;MASM..............................
if Solid
;$9.7.8
; Further test.
 db "CDS"db -@SizeStr(<CDS>)db $StreamParmsRec <1,2,0011b>
BifSTREAM:
endif
 Error49Bp

if Solid
;$9.8.2
 ParmsRec <0,0,1111b>
BifQUEUED:
endif
; We also use this one for just loading the value of a Bcode variable the
; stack.
 Qry Z.Cancel,BcodeInterpretjz @F
; See B4VALUE2
 UpMove V,Ve[$?OUTCOME]RetSi

; The Rexx queue is in Z.Serial when acted on.
@@:mov al,$SerialQuecall Serialize
; Length of aggregate is first word of Z.Serial.
; Items have their length at both ends of the item.
 z cxz si
@@:cmp si,Wptr Z.Serialjnb @Finc cxadd si,Wptr ss:Z.Serial[si+2]jmp @B
@@:Upz V.Mantissaz V.ExpAndmov Wptr V.Mantissa,cx
 pop CursorSiBackRet

if Solid
;$9.8.3
 db $WholeGEdb $WholeGEdb $WholeGEParmsRec <0,3,0001b>
BifRANDOM:
endif
 Up; Adjust to position of result.
; set ecx=minimum ebx=maximum
 z ecxmov ebx,Y.N1000dec ebx
 test al,81hjz @3p8Nonejpe @3p8Threejns @3p8Two
 mov ebx,V.Mantissacmp ebx,Y.N1e5jbe @3p8None
 mov al,31jmp Raise40
@3p8Three:
@3p8Two:cmp V.Dtype,$Omittedje @Fmov ecx,V.Mantissa@@:
 cmp V2.Dtype,$Omittedje @Fmov ebx,V2.Mantissa@@:
; Put Min and Max down for messages. (And result)
@3p8None:mov V.Mantissa,ecxmov V.ExpAnd,ebp
 mov V2.Mantissa,ebxmov V2.ExpAnd,ebp
; Change ebx to be the range.
 sub ebx,ecxjz @3p8Outjl Raise40p33cmp ebx,Y.N1e5jg Raise40p32
; The rest follows IBM but I don't suppose they will mind since Rick
; told SHARE all about it and inventive part is from Knuth.
 cmp al,81h+2*$BifRANDOMjne @F
; ConfigRandomSeed
 mov ecx,V3.Mantissanot ecxmov Z.Seed,ecxOn Z.Program,RandomSeeded
 jmp Fiddling;
@@:bts Z.Program,RandomSeededjc Seeded
; Set cx and dx from timer.
 mov ah,$DosTimeint 21hmov Wptr Z.Seed,cxmov Wptr Z.Seed+2,dx
; Might as well include the date.
 mov ah,$DosDateint 21hxor Wptr Z.Seed,cxxor Wptr Z.Seed+2,dx
Fiddling:
; Try to remove some non-randomness in relations of bits.
 mov cx,13@@:call Randomloop @B
Seeded:call Random
; Convert latest internal to result. First reverse the bits.
 mov cx,32@@:rcl eax,1rcr edx,1loop @Bmov eax,edx
; Divide by range+1
 inc ebxz edxdiv ebxadd V.Mantissa,edx
@3p8Out:pop CursorSiBackRet
Random:; ConfigRandomNext
 mov eax,Z.Seedmul Y.N1664525inc eaxmov Z.Seed,eaxret

if Solid
;$9.8.4
 ParmsRec <1,0,1111b>
BifSYMBOL:
endif
 call ToDsSiCx
; We are not setup to share code with compile time because "next char" at
; compile time can mean detecting end-of-buffer while execution time is
; about a string with length count.
; So we can share amongst SYMBOL & VALUE & VarPool & DROP() & EXPOSE()
; but not much more without a rewrite.
 JcxzQ IsBad
 call SymbolLookJcxzQ @F
IsBad:mov Dptr V.String,StringOrder('B','A','D',' ')jmp RetSym
@@:test bx,bxjnz IsLit
; NYI What nonsense bx is not result of Lookup.
 cmp Vbx.Dtype,$Droppedje IsLit
 mov Dptr V.String,StringOrder('V','A','R',' ')jmp RetSym
IsLit:mov Dptr V.String,StringOrder('L','I','T',' ')
RetSym:mov V.Dtype,$NullString+3pop CursorSiBackRet


; DS:SI:CX is the string to scan. Scan ends with string exhausted or end of
; part with symbol syntax. SI & CX are updated.  AX used. DX kept.
; Carry set iff not syntax of symbol.
; bx = 0 for a variable name.
SymbolLook:; si set to be past symbol.  bx used.
 push dxJcxzQ SymBadmov bx,Attributesz dx
; First character a letter if this is a variable name.
 mov al,[si]mov RawCharAh,alXlatBDLS
 jpe SymBadjns SymLitcmp RawCharAh,'.'je SymLit
; Go to limit of letters and digits.
SymLoop:inc dxlodsbXlatBDLSjpe @FLoopQ SymLoop@@:
 cmp dx,$Limit_Nameja SymBad
 z bxclcpop dxret
SymBad:stcpop dxret

; Scan to distinguish BAD from LIT.
SymRec record SRpad:11, HadDigits:1, HadDot:1, NotNumber:1, HadSign:1, HadE:1

SymLit:lodsb; At most one dot in a number.cmp RawCharAl,'.'
 jne @Ftest dl,mask HadSignjnz SymBadbts dx,HadDotjc SymNotNum@@:
; Specials not allowed except +- absorbed by exponent.
 XlatBDLSjpe SymBadjs SymLetor dl,mask HadDigitsjmp SymLoo
SymLet:test dl,mask NotNumberjnz SymLoo
 JcxzQ SymNotNumtest al,$Eejz SymNotNum
 test dl,mask HadDigitsjz SymNotNum
 bts dx,HadEjc SymNotNum
 cmp Bptr[si],'+'je SymSign
 cmp Bptr[si],'-'jne SymLoo
SymSign:test dl,mask NotNumberjnz SymBadinc sidec cxor dl,mask HadSign
SymLoo:LoopQ SymLit
 clcpop dxret

SymNotNum:test dl,mask HadSignjnz SymBador dl,mask NotNumberjmp SymLoo

Raise40p26:mov al,26jmp Raise40

if Solid
;$9.8.6
; Could have $Symbol here but better to do that in the routine.
 ParmsRec <1,2,1111b>
BifVALUE:
endif
 test al,81hjg @8p6Threejnz @8p6Two
; One argument - return it's value.
; Check it is not a bad symbol before do special interpret to get value.
 call ToDsSiCxJcxzQ Raise40p26
; We need a valid symbol and nothing left over.
 call SymbolLookjc Raise40p26TestReg cxjnz Raise40p26
 pop CursorSimov dx,offset B4VALUE1call LinkBcodemov Z.Stack,StackDi
 UpMove V,Ve[$?OUTCOME]ret
@8p6Two:; Check first is non-constant symbol.
 call ToDsSiCxJcxzQ Raise40p26
 call SymbolLookjc Raise40p26TestReg cxjnz Raise40p26
 TestReg bxmov al,43jnz Raise40
 Uppop CursorSimov dx,offset B4VALUE2jmp LinkBcodemov Z.Stack,StackDi

@8p6Three:; DOS environment pool.
; Since the code is in the DOS system for Get/Set of these variables it is
; a shame it is not made available. Still, doesn't look like it is.
; !! Check 3rd arg value. "ENVIRONMENT" used by Personal REXX.
; IBM DOS 7 ??
comment~ DOS hold the environment data in a segment, which means it's size
is available.  I have to assume it is safe to alter the content, within the
confines of the segment.
~
; NYI.  go back 13 bytes for word with para length. 'M' and our CS before.
; Check out the pool name.(NYI - use DosPool & length check)
 add StackDi,2*$StrideV
 call CONFIG_UPPER$$call ToDsSiCxmov al,37JcxzQ Raise40
 mv es,cspush dimov di,Yshape.DOSrepe cmpsbpop dijne Raise40
; Fold the value's name, even in the environment case.
 sub StackDi,2*$StrideV
 call CONFIG_UPPER$$call ToDsSiCx
; PSP ahead of code.
 mov ax,cssub ax,10hmov es,axmov es,es:[2Ch]push StackDiz di
@8p6Env:cmp Bptr es:[di],0mov al,36jz Raise40
; Compare this one with given.
; Maybe some chaos if a null in user's string? Or an '='?
 push cxpush sirepe cmpsbpop sipop cxjnz @F
 cmp Bptr es:[di],'='je @8p6
; Advance to next in environment.
@@:cmp Bptr es:[di-1],0je @8p6Envinc dijmp @B

@8p6:; Value follows after '=' up to null.
 inc dimov cx,-1z axrepne scasb; Find the null
 neg cxdec cxmov si,disub si,cxdec cx; SI for CX is result.
; Copy to be result.
 mv ds,espop StackDicall ResultSpace
 push StackDimov di,axRepmovsbpop StackDi
 jmp RetEsSi

if Solid
;$9.3.14
 ParmsRec <1,0,1111b>
BifLENGTH:
 Error49Bp; Not done by bif mechanism.
endif

@@:push CursorSicall ToDsSiCxpop CursorSi
Length$$:mov cl,V.Dtypetest cl,$Testjns @B
 mov V.ExpAnd,ebpz V.MantHigh
 jpe @Fand cx,7mov V.MantLow,cx@@:BackRet

 include bifs.inc
 end
