; After the freedoms in group order have been used, there are numeric
; relations between the codes for the syntax elements. These are made
; use of in actions when materializing the $s codes.  The $s codes are
; nearly compact but not in the best order for execution so there is
; later a $s to $p conversion.
; The relations that have to be fitted around are:
;BBBBBB  B           BB     BBBBBBBBBBBB                     BB  B
;                                          V   VV  VVVVV   V   VV
;                                            U   UU
;          P   PPP P   P   P
;         S   S   S
;                                       NN  N
;                                                       III
;      DD   DD
;                       LMM
; Also see intervals for DROP & EXPOSE type.(Got this wrong & had to fixup.)
; Also see needs of PosPlus PosMinus PosEq. (Would like to fit here but
; actually used flags.)
; Also need Length-Max-Min sequential.
S2P:
 Assert $sPercent eq $-S2P
BaseB equ $-$Percent
 Assert $ eq BaseB+$Percentdb $pIntDivide
 Assert $ eq BaseB+$Asteriskdb $pMultiply
 Assert $ eq BaseB+$Slashdb $pDivide
 Assert $ eq BaseB+$Remdb $pRemainder
 Assert $ eq BaseB+$Xordb $pXor
 Assert $ eq BaseB+$Ordb $pOr
; DROP and EXPOSE are treated together. Also DropList and ExposeList
 BaseD equ $-$DROP
 Assert $sDrop eq $-S2P
 Assert $ eq BaseD+$DROPdb $pDrop
 db $pExpose
 Assert $ eq BaseB+$Anddb $pAnd
; STEM/STREAM/NORMAL are treated together
BaseS equ $-$STEM
 Assert $sStem eq $-S2P
 Assert $ eq BaseS+$STEMdb $pStem
; PARSE sources are done together.
BaseP equ $-$WITH
 Assert $sWith eq $-S2P
 Assert $ eq BaseP+$WITHdb $pWith
 Assert $sDropList eq $-S2P
 db $pDropList
 db $pExposeList
 Assert $ eq BaseS+$STREAMdb $pStream
 Assert $ eq BaseP+$LINEINdb $pLineIn
 Assert $ eq BaseP+$SOURCEdb $pSource
 Assert $ eq BaseP+$VERSIONdb $pVersion
 Assert $ eq BaseS+$NORMALdb $pNormal
 Assert $ eq BaseP+$PULLdb $pPull
 db 0 ; Spare
 Assert $sMinus eq $-S2P
 Assert $ eq BaseB+$Minusdb $pSubtract
 Assert $ eq BaseB+$Plusdb $pAdd
 Assert $ eq BaseP+$VARdb $pWith; n.b.
 Assert $sLength eq $-S2P
 db $pLength
 db $pMax
 db $pMin
 Assert $ eq BaseP+$ARGdb $pArg
; Eq was forced to top of its group, in order to make comparisons compact.
 Assert $sEq eq $-S2P
 Assert $ eq BaseB+$Eqdb $pEq
 Assert $ eq BaseB+$Nedb $pNe
 Assert $ eq BaseB+$Ltdb $pLt
 Assert $ eq BaseB+$Ledb $pLe
 Assert $ eq BaseB+$Gedb $pGe
 Assert $ eq BaseB+$Gtdb $pGt
 Assert $sSeq eq $-S2P
 Assert $ eq BaseB+$Seqdb $pSeq
 Assert $ eq BaseB+$Snedb $pSne
 Assert $ eq BaseB+$Sltdb $pSlt
 Assert $ eq BaseB+$Sledb $pSle
 Assert $ eq BaseB+$Sgedb $pSge
 Assert $ eq BaseB+$Sgtdb $pSgt
; NUMERIC components are done together.
BaseN equ $-$DIGITS
 Assert $sDigits eq $-S2P
 Assert $ eq BaseN+$DIGITSdb $pDigits
 Assert $ eq BaseN+$FUZZdb $pFuzz
 db 0; $sTailed was here, now unneeded
; Several verbs are done together.
BaseV equ $-$NOP
 Assert $sNop eq $-S2P
 Assert $ eq BaseV+$NOPdb $pNop
 Assert $sForm eq $-S2P
 Assert $ eq BaseN+$FORMdb $pForm
BaseU equ $-$Not
 Assert $ eq BaseU+$Notdb $pNot
 Assert $sAddress eq $-S2Pdb $pAddress
 Assert $ eq BaseV+$INTERPRETdb $pInterpret
 Assert $ eq BaseV+$OPTIONSdb $pOptions
 Assert $sNegate eq $-S2P
 Assert $ eq BaseU+$Minusdb $pNegate
 Assert $sPositive eq $-S2P
 Assert $ eq BaseU+$Plusdb $pPositive
 Assert $sExit eq $-S2P
 Assert $ eq BaseV+$EXITdb $pExit
 Assert $ eq BaseV+$PUSHdb $pPush
 Assert $ eq BaseV+$QUEUEdb $pQueue
 Assert $sReturns eq $-S2P
 Assert $ eq BaseV+$RETURNdb $pReturns
 Assert $ eq BaseV+$SAYdb $pSay
 Assert $sNumber eq $-S2Pdb $pNumber
 db 0;
 Assert $sRaise eq $-S2Pdb $pRaise
 Assert $ eq BaseV+$TRACEdb $pTrace
 db 0; was $sCatDot now unneeded.
 Assert $ eq BaseB+$Abutdb $pAbut
 Assert $ eq BaseB+$Catdb $pCat
 Assert $sLeave eq $-S2P
 Assert $ eq BaseV+$LEAVEdb $pLeave
 Assert $sIterate eq $-S2P
 Assert $ eq BaseV+$ITERATEdb $pIterate
 Assert $ eq BaseB+$Powerdb $pPower
